
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/

function SearchEngine( id, name, pattern ) {
	this.PatternedObject( id, name, pattern, false );
}
    
function SearchEnginesHolder() {
	this.PatternedObjectsHolder( new NewSearchEngine(), 'URL' );
}
SearchEnginesHolder.rec = 'rec/rec_search_engines.php';
SearchEnginesHolder.objectClass = SearchEngine;
SearchEnginesHolder.objectTagName = 'search_engine';

ArdeClass.extend( SearchEnginesHolder, PatternedObjectsHolder );



SearchEngine.fromXml = function ( element ) {
	var id = ArdeXml.intAttribute( element, 'id' );
	var name = ArdeXml.attribute( element, 'name' );
	var pattern = ArdeXml.strElement( element, 'pattern' );
	return new SearchEngine( id, name, pattern );
}

SearchEngine.rec = 'rec/rec_search_engines.php';
ArdeClass.extend( SearchEngine, PatternedObject );

function NewSearchEngine() {
	this.NewPatternedObject();
}
NewSearchEngine.rec = 'rec/rec_search_engines.php';
NewSearchEngine.title = 'New Search Engine';
NewSearchEngine.addButtonName = 'Add Search Engine';
NewSearchEngine.objectClass = SearchEngine;
ArdeClass.extend( NewSearchEngine, NewPatternedObject );
