<?php
	/********************************************************************/
	/*                                                                  */
	/*      Copyright (C) 2004 Arash Dejkam, All Rights Reserved.       */
	/*      http://www.tracewatch.com                                   */
	/*                                                                  */
	/*      Please read the licence file distributed with this          */
	/*      file or the one available at tracewatch.com for             */
	/*      the terms under which you can use or modify this file.      */
	/*                                                                  */
	/********************************************************************/
    	
	global $ardeBase, $ardeUser, $ardeUserProfile;
	if( !isset( $ardeUserProfile ) ) $ardeUserProfile = 'default';
	
	if( !isset( $ardeBase ) ) {
		$ardeUserSettings = ardeUserGetSettings( $ardeUserProfile );
		$ardeBaseProfile = $ardeUserSettings[ 'base_profile' ];
		require_once dirname(__FILE__).'/../'.$ardeUserSettings[ 'to_base' ].'/lib/Global.php';
	}

	function ardeUserGetSettings( $profile ) {
		$settings = array();
		include dirname(__FILE__).'/../profiles/'.$profile.'/settings.php';
		return $settings;
	}
		
	class ArdeUserApp extends ArdeNoneBaseApp {
		
		var $version = '0.1';
		
		var $name = 'ardeUser';
		
		var $db;
		
		var $user;

		public function path( $target ) {
			return ardeSlashConcat( dirname(__FILE__).'/..', $target );
		}
		
		public function extPath( $appName, $target ) {
			return ardeSlashConcat( dirname(__FILE__).'/..', $this->settings[ 'to_'.$appName ], $target );
		}

	}
	
	$ardeUser = new ArdeUserApp( $ardeBase );
	$ardeUser->loadSettings( $ardeUserProfile );
?>